Subject: [bug#69558] [PATCH 0/2] gnu: Add emacs-lsp-booster rust app.

From: Efraim Flashner <[email-masked]>
Date: Wed, 6 Mar 2024 09:54:28 +0200

On Tue, Mar 05, 2024 at 10:01:38AM -0500, Suhail Singh wrote:
> Efraim Flashner <[email-masked]> writes:
> 
> > I had to downgrade rust-clap-verbose-flag-2 from 2.2.0 to 2.1.2
> 
> I believe you mean rust-clap-verbosity-flag-2 .

yep

> > since 2.2.0 wanted a newer version of clap than we had (and this way I
> > could add it straight to master, not to rust-team).
> 
> Thank you for doing that and taking the time to respond.  Though it does
> make me wonder how I was able to build my patch series if it needed a
> newer version of clap.  Wouldn't the guix build invocation have failed
> if that were the case?  Perhaps it did fail for you?

The way the cargo packages work #:cargo-inputs and
#:cargo-development-inputs are some fancy magic around pulling the
sources and some dependant sources into the build, so unless you also
explicitly built rust-clap-verbosity-flag@2 then it wasn't built while
you were testing it.

> Additionally, based on [crates-io] it seems that version 2.2.0 of
> clap-verbosity-flag depends on clap version ^4.0.0 and has a
> dev-dependency on clap version ^4.4.18.  Based on my understanding of
> the [caret-syntax] and cargo's treatment of it, it seems that both would
> be compatible with the current version of rust-clap-4 in Guix, i.e.,
> version 4.4.16.  Did I misunderstand something?

4.4.16 satisfies ^4.0.0 but doesn't satisfy ^4.4.18.  Something about
running the cargo builds inside the guix container means it needs to
satisfy all the constraints, even if they don't actually apply, like
when we need to pull in windows or apple dependencies.

> [crates-io]:
> <https://crates.io/crates/clap-verbosity-flag/2.2.0/dependencies>
> 
> [caret-syntax]:
> <https://doc.rust-lang.org/cargo/reference/specifying-dependencies.html#caret-requirements>
> 
> > I added a comment on emacs-lsp-booster that it was specifically emacs
> > and not emacs-minimal.
> 
> Yes, that's helpful to make explicit.  Good catch.
> 
> > Patches pushed!
> 
> Thank you!
> 
> -- 
> Suhail

-- 
Efraim Flashner   <[email-masked]>   רנשלפ םירפא
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted